#!/bin/bash

###################################
### bimg 1=iter,2=nqrf, 3=qcomp4, 4=qv	###
###################################
yisdir=./
bindir=${yisdir}/bin
datdir=${yisdir}/dat

iter=${1}
nqrf=${2}
qcomp=${3}
qv=${4}

csou=${datdir}/layer4.csou.H
crec=${datdir}/layer4.crec.H
bvel=${datdir}/layer4.${qv}.bvel.H

bq=${datdir}/layer4.vc.${qv}.bq.iter${iter}.H
bimg=${datdir}/layer4.vc.${qv}.bimg.iter${iter}.H

Pad beg1=200 end1=200 <${bvel} extend=1>junk.bvel.H
Pad beg1=200 end1=200 <${bq} extend=1>junk.q.H
${bindir}/bwi-wem3d.x csou=${csou} crec=${crec} bvel=junk.bvel.H bq=junk.q.H bimg=${bimg} mode=imgadj adj=y nws=90 oper="ssfpi" ntpx=25 nxpad_beg=50 nxpad_end=50 image_xmin=0 image_xmax=5000 offset=n  memchk=n  radian=n nvrf=3 nqrf=${nqrf} qcomp=${qcomp}
Rm junk.*.H
