!!!!!!!!!!!problematic, need to fix about the string problem

module util_axisIO
  use sep
  implicit none

  type, public :: myaxis
     integer   :: n
     real      :: o,d
     character(len=128) :: l
  end type myaxis

contains
  subroutine print_axis(axis)
    type(myaxis) ::axis
    write(0,*) "n,d,o =",axis%n,axis%d,axis%o
    write(0,*) "label=",axis%l
  end subroutine print_axis

  subroutine set_axis(axis,n,d,o,label)
    type(myaxis), intent(out):: axis
    integer :: n
    real ::o,d
    character (len=*) :: label
    integer :: len_str

    axis%n = n
    axis%d = d
    axis%o = o

    len_str = len(label)	
    !axis%l(1:len_str) = label(1:len_str)
    axis%l = label
  end subroutine set_axis
    
  subroutine hinaxis(axis,i,str_tg)
    integer    , intent(in)  :: i
    type(myaxis), intent(out) :: axis
    character (len=128)      :: buffer
    optional :: str_tg
    character(len=*) :: str_tg

    if (.not.present(str_tg)) then
       !read from program output .H file
       write (buffer, "(a,i1)" ) 'n',i
       call from_history(buffer,axis%n,1)
       write (buffer, "(a,i1)" ) 'o',i
       call from_history(buffer,axis%o,0.0)
       write (buffer, "(a,i1)" ) 'd',i
       call from_history(buffer,axis%d,1.0)
       write (buffer, "(a,i1)") 'label',i
       call from_history(buffer,axis%l," ")
    else
       write (buffer, "(a,i1)" ) 'n',i
       call from_aux(str_tg,buffer,axis%n,1)
       write (buffer, "(a,i1)" ) 'o',i
       call from_aux(str_tg,buffer,axis%o,0.0)
       write (buffer, "(a,i1)" ) 'd',i
       call from_aux(str_tg,buffer,axis%d,1.0)
       write (buffer, "(a,i1)") 'label',i
       call from_aux(str_tg,buffer,axis%l," ")
    endif
  end subroutine  hinaxis

  !----------------------------------------------------------------

  subroutine houtaxis(axis,i,str_tg)
    optional :: str_tg
    integer    , intent(in)  :: i
    type(myaxis), intent(in)  :: axis
    character (len=128)      :: buffer
    character(len=*) :: str_tg

    if (.not.present(str_tg)) then
 !write to program output .H file
       write (buffer, "(a,i1)" ) 'n',i
       call to_history(buffer,axis%n)
       write (buffer, "(a,i1)" ) 'o',i
       call to_history(buffer,axis%o)
       write (buffer, "(a,i1)" ) 'd',i
       call to_history(buffer,axis%d)
       write (buffer, "(a,i1)") 'label',i
       call to_history(buffer,axis%l)
    else
 !write to target file specified by str_tg
       write (buffer, "(a,i1)" ) 'n',i
       call to_history(buffer,axis%n,str_tg)
       write (buffer, "(a,i1)" ) 'o',i
       call to_history(buffer,axis%o,str_tg)
       write (buffer, "(a,i1)" ) 'd',i
       call to_history(buffer,axis%d,str_tg)
       write (buffer, "(a,i1)") 'label',i
       call to_history(buffer,axis%l,str_tg)
    end if
  end subroutine houtaxis

end module util_axisIO
