#!/bin/bash

###################################
### dimg 1=iter 2=slop_neg 3=qv	###
###################################
yisdir=./
bindir=${yisdir}/bin
datdir=${yisdir}/dat

iter=${1}
slop_neg=${2}
qv=${3}



bimg=${datdir}/layer4.vc.${qv}.bimg.iter${iter}.H
dimg=${datdir}/layer4.vc.${qv}.dimg.iter${iter}.H


<${bimg} ${bindir}/dimg.x  slop_neg=${slop_neg} neigh=n nref=150 ver=n fmin=0.01 fmax=0.04 nwin=8 lwin=200 nsmt_mx=30 nsmt_spex=1 rect_spex=1  nsmt_slop=1 rectx_slop=5 rectz_slop=5 |Window3d f3=100 squeeze=n|Pad beg3=100>${dimg}
