#!/bin/sh

###################################
### Q inversion 1=bqbv or bqtv	###
###################################

### Initial input
### csou.H; crec.H
### bvel.H
### bq.iter0.H
### alfa.iter0.H
yisdir=./
bindir=${yisdir}/bin
datdir=${yisdir}/dat
shdir=${yisdir}/shScript/VelPre

  cd ${yisdir}

qv=${1}

######################################################################
### iteration initialize					  ###
######################################################################

 ${shdir}/shImg.sh 0 1 n ${qv}
 ${shdir}/shDimg.sh 0 y ${qv}
 ${shdir}/shGrad.sh 0 1 n ${qv}
 ${shdir}/shGradprc.sh 0 ${qv}
######################################################################
### iteration begins 					           ###
######################################################################

  for iter in {1..1} 
  do

 ${shdir}/shLinsrch.sh  ${iter} ${qv}
 ${shdir}/shImg.sh  ${iter} 3 y ${qv}
 ${shdir}/shDimg.sh  ${iter} n ${qv}
 ${shdir}/shGrad.sh ${iter} 3 y ${qv}
 ${shdir}/shGradprc.sh ${iter} ${qv}

  done
