program layer4Vpre
  use sep
  use util_axisIO


  implicit none

 
  integer			:: n1, n2, n3, i1, i2, i3
  real, allocatable 		:: in(:, :, :), out(:, :, :)
  real				:: c1, c2, c3, ivp2




  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ('n2',n2)
  call from_history ('n3',n3)






  allocate(in(n1, n2, n3),out(n1 ,n2, n3) )

  call sep_read(in)
  c1=3.8; c2=3.6; c3=5.97/1000

  do i1=1,n1
  do i2=1,n2 
  do i3=1,n3
	ivp2=1/(in(i1, i2, i3)/1000)/(in(i1, i2, i3)/1000)
	out(i1, i2, i3)=(0.5*c1*ivp2/(c2*ivp2+c3)-0.5)
	!write(0,*) "ivp2,out", ivp2, out(i1, i2, i3),0.5*c1*ivp2/(c2*ivp2+c3)

  end do
  end do
  end do
  out(:,:,1:50)=0.0
  c1=3.8; c2=2.9; c3=2.051/100
  do i1=n1/2,n1
  do i2=1,n2 
  do i3=50,100
	ivp2=1/(in(i1, i2, i3)/1000)/(in(i1, i2, i3)/1000)
	out(i1, i2, i3)=(0.5*c1*ivp2/(c2*ivp2+c3)-0.5)
	!write(0,*) "ivp2,out", ivp2, out(i1, i2, i3),0.5*c1*ivp2/(c2*ivp2+c3)

  end do
  end do
  end do
  call sep_write(out)
  deallocate(in, out)


  call sep_close()
end program

